import board
import time
from adafruit_apds9960.apds9960 import APDS9960
import adafruit_mpr121
import busio
import adafruit_vl53l1x
import digitalio
from audiocore import WaveFile
from adafruit_debouncer import Debouncer
from audiopwmio import PWMAudioOut as AudioOut
from audiomp3 import MP3Decoder
from adafruit_debouncer import Debouncer
import random

try:
    from audioio import AudioOut
except ImportError:
    try:
        from audiopwmio import PWMAudioOut as AudioOut
    except ImportError:
        print("This board does not support AudioOut")
        pass # Not all boards can play audio with AudioOut


audio = AudioOut(board.D3)

path = 'sounds/'

filename = "Gun.mp3"
mp3_file = open(path + filename, "rb")
decoder = MP3Decoder(mp3_file)

def play_mp3(filename):
    decoder.file = open(path + filename, "rb")
    audio.play(decoder)
    while audio.playing:
        if filename == 'gun.mp3':
            reaction = 0
            while distance():
                reaction += .01
                time.sleep(.01)
            return reaction


button_input = digitalio.DigitalInOut(board.D2)
button_input.switch_to_input(pull=digitalio.Pull.UP)
button = Debouncer(button_input)

i2c = board.I2C()
distance_sensor = adafruit_vl53l1x.VL53L1X(i2c)
distance_sensor.distance_mode = 1
distance_sensor.timing_budget = 100

distance_sensor.start_ranging() # start the sensor

def distance():
    sensor = distance_sensor.distance
    if type(sensor) == float:
        return True
    else:
        return False

while True:
    if distance_sensor.data_ready:
        button.update()
        if button.fell:
            play_mp3('mark.mp3')
            print('Mark')
            time.sleep(random.uniform(4,6))
            if distance():
                play_mp3('set.mp3')
                print('Set')
                time.sleep(random.uniform(1,3))
                if distance() == False:
                    print('False Start')
                    play_mp3('false_start.mp3')
                else:
                    print('GO!!!')
                    reaction = play_mp3('gun.mp3')
                    reaction_list = list(str(round(reaction,2)))
                    print(reaction_list)
                    while True:
                        button.update()
                        if button.fell:
                            play_mp3('reaction.mp3')
                            print('Your reaction time is')
                            for i in range(len(reaction_list)):
                                if reaction_list[i] == '.':
                                    play_mp3('point.mp3')
                                    print('.')
                                else:
                                    play_mp3(f'{reaction_list[i]}.mp3')
                                    print(reaction_list[i])
                            play_mp3('seconds.mp3')
                            print('seconds')
                            break
            else:
                play_mp3('no.mp3')


